#include "StdAfx.h"
#include "Chromakey.h"
#include "GDIStatic.h"

CGDIStatic::CGDIStatic(void)
{
	m_dMagni = 0;
	m_image = NULL;

	m_r = 0;
	m_g = 0;
	m_b = 0;
}

CGDIStatic::~CGDIStatic(void)
{
}

BEGIN_MESSAGE_MAP(CGDIStatic, CWnd)
	ON_WM_PAINT()
ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()

void CGDIStatic::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ɃbZ[W nh R[hǉ܂B
	// `惁bZ[W CWnd::OnPaint() ĂяoȂłB

	CRect rt;
	GetClientRect(rt);

	if(!m_image){
		dc.FillSolidRect(rt, ::GetSysColor(COLOR_3DFACE));

	} else {

		// DCGDI+ɂ
		Graphics* graphics = Graphics::FromHDC(dc.m_hDC);

		// `TCY
		Rect rtOut;

		rtOut.X = 0;
		rtOut.Y = 0;
		rtOut.Width  =	(INT)((double)m_image->GetWidth() / m_dMagni);
		rtOut.Height =	(INT)((double)m_image->GetHeight() / m_dMagni);


		// IuWFNgŜImage`悵ĂȂ`擾
		CRect rtcOut(0,0, rtOut.Width, rtOut.Height);
		CRect rtFill;
		rtFill.SubtractRect(rt, rtcOut);


		// wihԂ
		dc.FillSolidRect(rtFill, ::GetSysColor(COLOR_APPWORKSPACE));

		// DCImage]
		graphics->DrawImage(	m_image,
								rtOut,
								0, 0,
								m_image->GetWidth(),
								m_image->GetHeight(),
								UnitPixel);

	}

}



// 摜t@Cǂݍ
//
void CGDIStatic::loadPicture(CStringW strFileName)
{

	BOOL bRet = FALSE;

    // 摜t@C擾(t@CbN)
	Image* imageOrgn = Bitmap::FromFile(strFileName);
	Status st = imageOrgn->GetLastStatus();
	if(st == Ok){

		CSize szImage(imageOrgn->GetWidth(), imageOrgn->GetHeight());

		// wTCYBitmap쐬
		delete m_image;
		m_image = NULL;
		m_image = new Bitmap(szImage.cx, szImage.cy);

		// zOtBbNẌ쐬
		Graphics* grpTmp = Graphics::FromImage(m_image);

		// imageOrgnimageɃvg
		grpTmp->DrawImage( imageOrgn, 0, 0, szImage.cx, szImage.cy);

		// zOtBbNXj
		delete grpTmp;
		grpTmp = NULL;

		// imageOrgnJ(t@CJ)
		delete imageOrgn;
		imageOrgn = NULL;


		// g̃sNZTCY擾
		CRect rt;
		GetClientRect(rt);


		// 䗦vZ
		double dWid1 = (double)m_image->GetWidth();
		double dWid2 = (double)rt.Width();
		double dMagniW = dWid1 / dWid2;

		double dHgt1 = (double)m_image->GetHeight();
		double dHgt2 = (double)rt.Height();
		double dMagniH = dHgt1 / dHgt2;

		// 傫قgp
		m_dMagni = max(dMagniW, dMagniH);

	} else {
		delete imageOrgn;
		imageOrgn = NULL;

		delete m_image;
		m_image = NULL;

	}
	RedrawWindow();

}



// ۑ
//
// 
// CStringW	strFName	t@Cl[
// CString	strExt		gq
//
BOOL CGDIStatic::savePicture(CStringW strFName, CString strExt)
{

	CStringW strEnc;

	// 啶ɕϊ
	CString strExtU = strExt = strExt.MakeUpper();

	// GR[_
	if(strExtU == "PNG"){
		strEnc = L"image/png";

	} else if(strExtU == "JPG" || strExtU == "JPEG"){
		strEnc = L"image/jpeg";

	} else if(strExtU == "BMP"){
		strEnc = L"image/bmp";

	} else {
		return FALSE;

	}

	// GR[_
	CLSID  encoderClsid;
	INT    result = GetEncoderClsid(strEnc, &encoderClsid);

	if(result < 0){
		return FALSE;

	} else {
		// ۑ
		if(m_image){
			m_image->Save(strFName, &encoderClsid);
		}
	}

	return TRUE;

}



// 摜ۑGR[_
// http://msdn.microsoft.com/en-us/library/ms533843.aspx
// image/bmp 
// image/jpeg 
// image/gif 
// image/tiff 
// image/png 
int CGDIStatic::GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          // number of image encoders
   UINT  size = 0;         // size of the image encoder array in bytes

   ImageCodecInfo* pImageCodecInfo = NULL;

   GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}



// ێĂBitmap̃Rs[擾
//
Bitmap* CGDIStatic::getBitmap(void)
{

	if(m_image){
		// N[
		return m_image->Clone(Rect(0,0,m_image->GetWidth(), m_image->GetHeight()), PixelFormat24bppRGB); 

	} else {
		return NULL;
	}
}



// O쐬Bitmap`pBitmapɃRs[
//
// 
// Bitmap* bmp	Rs[Bitmap
//
void CGDIStatic::setBitmap(Bitmap* bmp)
{

	CSize szImage(bmp->GetWidth(), bmp->GetHeight());

	// N[
	delete m_image;
	m_image = bmp->Clone(Rect(0,0, szImage.cx, szImage.cy), PixelFormat24bppRGB);

	// g̃sNZTCY擾
	CRect rt;
	GetClientRect(rt);

	// 䗦vZ
	double dWid1 = (double)m_image->GetWidth();
	double dWid2 = (double)rt.Width();
	double dMagniW = dWid1 / dWid2;

	double dHgt1 = (double)m_image->GetHeight();
	double dHgt2 = (double)rt.Height();
	double dMagniH = dHgt1 / dHgt2;

	// 傫قgp
	m_dMagni = max(dMagniW, dMagniH);

}

// ێBitmapN}L[摜ɕϊ
//
// 
// int				mode	Ӱ
// unsigned char	R		R
// unsigned char	G		G
// unsigned char	B		B
//
void CGDIStatic::CreateChroma(int mode, unsigned char R, unsigned char G, unsigned char B)
{
	for(DWORD y = 0; y < m_image->GetHeight(); y++){
		for(DWORD x= 0; x < m_image->GetWidth(); x++){
			Color COL;

			// wWRGBl擾
			m_image->GetPixel(x, y, &COL);

			BYTE cr = COL.GetR();
			BYTE cg = COL.GetG();
			BYTE cb = COL.GetB();

			switch(mode){
			case 0:
				if(cr == R && cg == G && cb == B){
					m_image->SetPixel(x, y, Color(255,255,255));
				} else {
					m_image->SetPixel(x, y, Color(0,0,0));
				}
				break;
			case 1:
				if(cr != R && cg != G && cb != B){
					m_image->SetPixel(x, y, Color(255,255,255));
				} else {
					m_image->SetPixel(x, y, Color(0,0,0));
				}
				break;
			}
		}
	}
}

// _uNbNCxg(NOTIFYvpeBTRUEɂ邱Ɓj
void CGDIStatic::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B

	if(m_image){
		Color COL;
		// wWRGBl擾
		m_image->GetPixel(point.x * m_dMagni, point.y * m_dMagni, &COL);

		m_r = COL.GetR();
		m_g = COL.GetG();
		m_b = COL.GetB();

		GetParent()->SendMessage(WM_USER + 1);
	}

	CWnd::OnLButtonDblClk(nFlags, point);
}
